/* FileStore.c generated by valac 0.48.5, the Vala compiler
 * generated from FileStore.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "deja.h"
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gobject/gvaluecollector.h>

#define TYPE_FILE_STORE (file_store_get_type ())
#define FILE_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_STORE, FileStore))
#define FILE_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_STORE, FileStoreClass))
#define IS_FILE_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_STORE))
#define IS_FILE_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_STORE))
#define FILE_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_STORE, FileStoreClass))

typedef struct _FileStore FileStore;
typedef struct _FileStoreClass FileStoreClass;
typedef struct _FileStorePrivate FileStorePrivate;

#define FILE_STORE_TYPE_FILE_NODE (file_store_file_node_get_type ())
#define FILE_STORE_FILE_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILE_STORE_TYPE_FILE_NODE, FileStoreFileNode))
#define FILE_STORE_FILE_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILE_STORE_TYPE_FILE_NODE, FileStoreFileNodeClass))
#define FILE_STORE_IS_FILE_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILE_STORE_TYPE_FILE_NODE))
#define FILE_STORE_IS_FILE_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILE_STORE_TYPE_FILE_NODE))
#define FILE_STORE_FILE_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILE_STORE_TYPE_FILE_NODE, FileStoreFileNodeClass))

typedef struct _FileStoreFileNode FileStoreFileNode;
typedef struct _FileStoreFileNodeClass FileStoreFileNodeClass;
enum  {
	FILE_STORE_0_PROPERTY,
	FILE_STORE_CAN_GO_UP_PROPERTY,
	FILE_STORE_SEARCH_FILTER_PROPERTY,
	FILE_STORE_NUM_PROPERTIES
};
static GParamSpec* file_store_properties[FILE_STORE_NUM_PROPERTIES];
typedef enum  {
	FILE_STORE_COLUMN_FILENAME = 0,
	FILE_STORE_COLUMN_SORT_KEY,
	FILE_STORE_COLUMN_ICON,
	FILE_STORE_COLUMN_GICON,
	FILE_STORE_COLUMN_MODIFIED,
	FILE_STORE_COLUMN_PATH
} FileStoreColumn;

#define FILE_STORE_TYPE_COLUMN (file_store_column_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _file_store_file_node_unref0(var) ((var == NULL) ? NULL : (var = (file_store_file_node_unref (var), NULL)))
typedef struct _FileStoreFileNodePrivate FileStoreFileNodePrivate;
typedef struct _Block8Data Block8Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _FileStoreParamSpecFileNode FileStoreParamSpecFileNode;

struct _FileStore {
	GtkListStore parent_instance;
	FileStorePrivate * priv;
};

struct _FileStoreClass {
	GtkListStoreClass parent_class;
};

struct _FileStorePrivate {
	gboolean _can_go_up;
	gchar* _search_filter;
	FileStoreFileNode* root;
	FileStoreFileNode* current;
};

struct _FileStoreFileNode {
	GTypeInstance parent_instance;
	volatile int ref_count;
	FileStoreFileNodePrivate * priv;
	FileStoreFileNode* parent;
	gchar* filename;
	gchar* type;
	GDateTime* modified;
	GHashTable* children;
	gchar** search_tokens;
	gint search_tokens_length1;
	gint _search_tokens_size_;
};

struct _FileStoreFileNodeClass {
	GTypeClass parent_class;
	void (*finalize) (FileStoreFileNode *self);
};

struct _Block8Data {
	int _ref_count_;
	FileStore* self;
	gchar** needle_tokens;
	gint needle_tokens_length1;
};

struct _FileStoreParamSpecFileNode {
	GParamSpec parent_instance;
};

static gint FileStore_private_offset;
static gpointer file_store_parent_class = NULL;
static gpointer file_store_file_node_parent_class = NULL;

GType file_store_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileStore, g_object_unref)
static gpointer file_store_file_node_ref (gpointer instance);
static void file_store_file_node_unref (gpointer instance);
static GParamSpec* file_store_param_spec_file_node (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags) G_GNUC_UNUSED;
static void file_store_value_set_file_node (GValue* value,
                                     gpointer v_object) G_GNUC_UNUSED;
static void file_store_value_take_file_node (GValue* value,
                                      gpointer v_object) G_GNUC_UNUSED;
static gpointer file_store_value_get_file_node (const GValue* value) G_GNUC_UNUSED;
static GType file_store_file_node_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileStoreFileNode, file_store_file_node_unref)
GType file_store_column_get_type (void) G_GNUC_CONST;
void file_store_register_operation (FileStore* self,
                                    DejaDupOperationFiles* op);
static FileStoreFileNode* file_store_file_node_new (FileStoreFileNode* parent_in,
                                             const gchar* filename_in,
                                             const gchar* type_in,
                                             GDateTime* modified_in);
static FileStoreFileNode* file_store_file_node_construct (GType object_type,
                                                   FileStoreFileNode* parent_in,
                                                   const gchar* filename_in,
                                                   const gchar* type_in,
                                                   GDateTime* modified_in);
static void file_store_set_current (FileStore* self,
                             FileStoreFileNode* node);
static void file_store_handle_listed_files (FileStore* self,
                                     DejaDupOperationFiles* op,
                                     const gchar* date,
                                     const gchar* file,
                                     const gchar* type);
static void _file_store_handle_listed_files_deja_dup_operation_files_listed_current_files (DejaDupOperationFiles* _sender,
                                                                                    const gchar* date,
                                                                                    const gchar* file,
                                                                                    const gchar* type,
                                                                                    gpointer self);
static void file_store_handle_done (FileStore* self,
                             DejaDupOperation* op,
                             gboolean success,
                             gboolean cancelled,
                             const gchar* detail);
static void _file_store_handle_done_deja_dup_operation_done (DejaDupOperation* _sender,
                                                      gboolean success,
                                                      gboolean cancelled,
                                                      const gchar* detail,
                                                      gpointer self);
gboolean file_store_go_down (FileStore* self,
                             GtkTreePath* path);
void file_store_go_up (FileStore* self);
gboolean file_store_get_can_go_up (FileStore* self);
gchar* file_store_get_full_path (FileStore* self,
                                 GtkTreePath* path);
GFile* file_store_get_file (FileStore* self,
                            GtkTreePath* path);
static void file_store_update_search (FileStore* self);
const gchar* file_store_get_search_filter (FileStore* self);
static void file_store_recursive_search (FileStore* self,
                                  gchar** needle_tokens,
                                  gint needle_tokens_length1,
                                  FileStoreFileNode* node);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda31_ (Block8Data* _data8_,
                  const gchar* name,
                  FileStoreFileNode* child);
static gchar** _vala_array_dup3 (gchar** self,
                          gint length);
static void file_store_insert_file (FileStore* self,
                             FileStoreFileNode* node);
static void ___lambda31__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static void file_store_set_can_go_up (FileStore* self,
                               gboolean value);
static void __lambda30_ (FileStore* self,
                  const gchar* name,
                  FileStoreFileNode* child);
static void ___lambda30__gh_func (gconstpointer key,
                           gconstpointer value,
                           gpointer self);
static gchar* file_store_collate_key (FileStore* self,
                               FileStoreFileNode* node);
static void file_store_clear_metadir (FileStore* self);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
FileStore* file_store_new (void);
FileStore* file_store_construct (GType object_type);
void file_store_set_search_filter (FileStore* self,
                                   const gchar* value);
static void _file_store_file_node_unref0_ (gpointer var);
static void file_store_file_node_finalize (FileStoreFileNode * obj);
static GType file_store_file_node_get_type_once (void);
static GObject * file_store_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static gint _file_store___lambda32_ (FileStore* self,
                              GtkTreeModel* m,
                              GtkTreeIter* a,
                              GtkTreeIter* b);
static gint __file_store___lambda32__gtk_tree_iter_compare_func (GtkTreeModel* model,
                                                          GtkTreeIter* a,
                                                          GtkTreeIter* b,
                                                          gpointer self);
static void _file_store_update_search_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self);
static void file_store_finalize (GObject * obj);
static GType file_store_get_type_once (void);
static void _vala_file_store_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_file_store_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
file_store_get_instance_private (FileStore* self)
{
	return G_STRUCT_MEMBER_P (self, FileStore_private_offset);
}

G_GNUC_NO_INLINE static GType
file_store_column_get_type_once (void)
{
	static const GEnumValue values[] = {{FILE_STORE_COLUMN_FILENAME, "FILE_STORE_COLUMN_FILENAME", "filename"}, {FILE_STORE_COLUMN_SORT_KEY, "FILE_STORE_COLUMN_SORT_KEY", "sort-key"}, {FILE_STORE_COLUMN_ICON, "FILE_STORE_COLUMN_ICON", "icon"}, {FILE_STORE_COLUMN_GICON, "FILE_STORE_COLUMN_GICON", "gicon"}, {FILE_STORE_COLUMN_MODIFIED, "FILE_STORE_COLUMN_MODIFIED", "modified"}, {FILE_STORE_COLUMN_PATH, "FILE_STORE_COLUMN_PATH", "path"}, {0, NULL, NULL}};
	GType file_store_column_type_id;
	file_store_column_type_id = g_enum_register_static ("FileStoreColumn", values);
	return file_store_column_type_id;
}

GType
file_store_column_get_type (void)
{
	static volatile gsize file_store_column_type_id__volatile = 0;
	if (g_once_init_enter (&file_store_column_type_id__volatile)) {
		GType file_store_column_type_id;
		file_store_column_type_id = file_store_column_get_type_once ();
		g_once_init_leave (&file_store_column_type_id__volatile, file_store_column_type_id);
	}
	return file_store_column_type_id__volatile;
}

static void
_file_store_handle_listed_files_deja_dup_operation_files_listed_current_files (DejaDupOperationFiles* _sender,
                                                                               const gchar* date,
                                                                               const gchar* file,
                                                                               const gchar* type,
                                                                               gpointer self)
{
	file_store_handle_listed_files ((FileStore*) self, _sender, date, file, type);
}

static void
_file_store_handle_done_deja_dup_operation_done (DejaDupOperation* _sender,
                                                 gboolean success,
                                                 gboolean cancelled,
                                                 const gchar* detail,
                                                 gpointer self)
{
	file_store_handle_done ((FileStore*) self, _sender, success, cancelled, detail);
}

void
file_store_register_operation (FileStore* self,
                               DejaDupOperationFiles* op)
{
	FileStoreFileNode* _tmp0_;
	FileStoreFileNode* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	_tmp0_ = file_store_file_node_new (NULL, "", "dir", NULL);
	_file_store_file_node_unref0 (self->priv->root);
	self->priv->root = _tmp0_;
	_tmp1_ = self->priv->root;
	file_store_set_current (self, _tmp1_);
	g_signal_connect_object (op, "listed-current-files", (GCallback) _file_store_handle_listed_files_deja_dup_operation_files_listed_current_files, self, 0);
	g_signal_connect_object ((DejaDupOperation*) op, "done", (GCallback) _file_store_handle_done_deja_dup_operation_done, self, 0);
}

static gpointer
_file_store_file_node_ref0 (gpointer self)
{
	return self ? file_store_file_node_ref (self) : NULL;
}

gboolean
file_store_go_down (FileStore* self,
                    GtkTreePath* path)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	gchar* filename = NULL;
	GtkTreeIter _tmp2_;
	gchar* _tmp3_ = NULL;
	FileStoreFileNode* child = NULL;
	FileStoreFileNode* _tmp4_;
	GHashTable* _tmp5_;
	const gchar* _tmp6_;
	gconstpointer _tmp7_;
	FileStoreFileNode* _tmp8_;
	gboolean _tmp9_ = FALSE;
	FileStoreFileNode* _tmp10_;
	FileStoreFileNode* _tmp13_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp1_ = gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp0_, path);
	iter = _tmp0_;
	if (!_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = iter;
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp2_, FILE_STORE_COLUMN_FILENAME, &_tmp3_, -1);
	_g_free0 (filename);
	filename = _tmp3_;
	_tmp4_ = self->priv->current;
	_tmp5_ = _tmp4_->children;
	_tmp6_ = filename;
	_tmp7_ = g_hash_table_lookup (_tmp5_, _tmp6_);
	_tmp8_ = _file_store_file_node_ref0 ((FileStoreFileNode*) _tmp7_);
	child = _tmp8_;
	_tmp10_ = child;
	if (_tmp10_ == NULL) {
		_tmp9_ = TRUE;
	} else {
		FileStoreFileNode* _tmp11_;
		const gchar* _tmp12_;
		_tmp11_ = child;
		_tmp12_ = _tmp11_->type;
		_tmp9_ = g_strcmp0 (_tmp12_, "dir") != 0;
	}
	if (_tmp9_) {
		result = FALSE;
		_file_store_file_node_unref0 (child);
		_g_free0 (filename);
		return result;
	}
	_tmp13_ = child;
	file_store_set_current (self, _tmp13_);
	result = TRUE;
	_file_store_file_node_unref0 (child);
	_g_free0 (filename);
	return result;
}

void
file_store_go_up (FileStore* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_can_go_up;
	if (_tmp0_) {
		FileStoreFileNode* _tmp1_;
		FileStoreFileNode* _tmp2_;
		_tmp1_ = self->priv->current;
		_tmp2_ = _tmp1_->parent;
		file_store_set_current (self, _tmp2_);
	}
}

gchar*
file_store_get_full_path (FileStore* self,
                          GtkTreePath* path)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
	gchar* filename = NULL;
	GtkTreeIter _tmp2_;
	gchar* _tmp3_ = NULL;
	FileStoreFileNode* parent = NULL;
	FileStoreFileNode* _tmp4_;
	FileStoreFileNode* _tmp5_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp1_ = gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp0_, path);
	iter = _tmp0_;
	if (!_tmp1_) {
		result = NULL;
		return result;
	}
	_tmp2_ = iter;
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp2_, FILE_STORE_COLUMN_FILENAME, &_tmp3_, -1);
	_g_free0 (filename);
	filename = _tmp3_;
	_tmp4_ = self->priv->current;
	_tmp5_ = _file_store_file_node_ref0 (_tmp4_);
	parent = _tmp5_;
	while (TRUE) {
		FileStoreFileNode* _tmp6_;
		FileStoreFileNode* _tmp7_;
		FileStoreFileNode* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		FileStoreFileNode* _tmp12_;
		FileStoreFileNode* _tmp13_;
		FileStoreFileNode* _tmp14_;
		_tmp6_ = parent;
		_tmp7_ = _tmp6_->parent;
		if (!(_tmp7_ != NULL)) {
			break;
		}
		_tmp8_ = parent;
		_tmp9_ = _tmp8_->filename;
		_tmp10_ = filename;
		_tmp11_ = g_strdup_printf ("%s/%s", _tmp9_, _tmp10_);
		_g_free0 (filename);
		filename = _tmp11_;
		_tmp12_ = parent;
		_tmp13_ = _tmp12_->parent;
		_tmp14_ = _file_store_file_node_ref0 (_tmp13_);
		_file_store_file_node_unref0 (parent);
		parent = _tmp14_;
	}
	result = filename;
	_file_store_file_node_unref0 (parent);
	return result;
}

GFile*
file_store_get_file (FileStore* self,
                     GtkTreePath* path)
{
	gchar* filepath = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = file_store_get_full_path (self, path);
	filepath = _tmp0_;
	_tmp1_ = filepath;
	if (_tmp1_ == NULL) {
		result = NULL;
		_g_free0 (filepath);
		return result;
	}
	_tmp2_ = filepath;
	_tmp3_ = g_strconcat ("/", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_file_new_for_path (_tmp4_);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	result = _tmp6_;
	_g_free0 (filepath);
	return result;
}

static void
file_store_update_search (FileStore* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gchar** needle_tokens = NULL;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint needle_tokens_length1;
	gint _needle_tokens_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	FileStoreFileNode* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->_search_filter;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->_search_filter;
		_tmp0_ = g_strcmp0 (_tmp2_, "") == 0;
	}
	if (_tmp0_) {
		FileStoreFileNode* _tmp3_;
		_tmp3_ = self->priv->current;
		file_store_set_current (self, _tmp3_);
		return;
	}
	_tmp4_ = self->priv->_search_filter;
	_tmp6_ = _tmp5_ = g_str_tokenize_and_fold (_tmp4_, "", NULL);
	needle_tokens = _tmp6_;
	needle_tokens_length1 = _vala_array_length (_tmp5_);
	_needle_tokens_size_ = needle_tokens_length1;
	gtk_list_store_clear ((GtkListStore*) self);
	_tmp7_ = needle_tokens;
	_tmp7__length1 = needle_tokens_length1;
	_tmp8_ = self->priv->current;
	file_store_recursive_search (self, _tmp7_, (gint) _tmp7__length1, _tmp8_);
	needle_tokens = (_vala_array_free (needle_tokens, needle_tokens_length1, (GDestroyNotify) g_free), NULL);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		FileStore* self;
		self = _data8_->self;
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gint length)
{
	gchar** result;
	gint i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
__lambda31_ (Block8Data* _data8_,
             const gchar* name,
             FileStoreFileNode* child)
{
	FileStore* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gboolean all_matched = FALSE;
	self = _data8_->self;
	g_return_if_fail (name != NULL);
	g_return_if_fail (child != NULL);
	_tmp0_ = child->search_tokens;
	_tmp0__length1 = child->search_tokens_length1;
	if (_tmp0_ == NULL) {
		gchar** unicode_tokens = NULL;
		gint unicode_tokens_length1 = 0;
		gint _unicode_tokens_size_ = 0;
		gchar** ascii_tokens = NULL;
		gint ascii_tokens_length1 = 0;
		gint _ascii_tokens_size_ = 0;
		const gchar* _tmp1_;
		gchar** _tmp2_ = NULL;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gchar** all_tokens = NULL;
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar** _tmp6_;
		gint _tmp6__length1;
		gchar** _tmp7_;
		gint all_tokens_length1;
		gint _all_tokens_size_;
		gchar** _tmp23_;
		gint _tmp23__length1;
		gchar** _tmp24_;
		gint _tmp24__length1;
		_tmp1_ = child->filename;
		_tmp4_ = _tmp3_ = g_str_tokenize_and_fold (_tmp1_, "", &_tmp2_);
		ascii_tokens = (_vala_array_free (ascii_tokens, ascii_tokens_length1, (GDestroyNotify) g_free), NULL);
		ascii_tokens = _tmp2_;
		ascii_tokens_length1 = -1;
		_ascii_tokens_size_ = ascii_tokens_length1;
		ascii_tokens_length1 = _vala_array_length (ascii_tokens);
		unicode_tokens = (_vala_array_free (unicode_tokens, unicode_tokens_length1, (GDestroyNotify) g_free), NULL);
		unicode_tokens = _tmp4_;
		unicode_tokens_length1 = _vala_array_length (_tmp3_);
		_unicode_tokens_size_ = unicode_tokens_length1;
		_tmp5_ = unicode_tokens;
		_tmp5__length1 = unicode_tokens_length1;
		_tmp6_ = ascii_tokens;
		_tmp6__length1 = ascii_tokens_length1;
		_tmp7_ = g_new0 (gchar*, (_tmp5__length1 + _tmp6__length1) + 1);
		all_tokens = _tmp7_;
		all_tokens_length1 = _tmp5__length1 + _tmp6__length1;
		_all_tokens_size_ = all_tokens_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp8_ = FALSE;
				_tmp8_ = TRUE;
				while (TRUE) {
					gchar** _tmp10_;
					gint _tmp10__length1;
					gchar** _tmp11_;
					gint _tmp11__length1;
					gchar** _tmp12_;
					gint _tmp12__length1;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					if (!_tmp8_) {
						gint _tmp9_;
						_tmp9_ = i;
						i = _tmp9_ + 1;
					}
					_tmp8_ = FALSE;
					_tmp10_ = unicode_tokens;
					_tmp10__length1 = unicode_tokens_length1;
					if (!(i < _tmp10__length1)) {
						break;
					}
					_tmp11_ = all_tokens;
					_tmp11__length1 = all_tokens_length1;
					_tmp12_ = unicode_tokens;
					_tmp12__length1 = unicode_tokens_length1;
					_tmp13_ = _tmp12_[i];
					_tmp14_ = g_strdup (_tmp13_);
					_g_free0 (_tmp11_[i]);
					_tmp11_[i] = _tmp14_;
				}
			}
		}
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp15_ = FALSE;
				_tmp15_ = TRUE;
				while (TRUE) {
					gchar** _tmp17_;
					gint _tmp17__length1;
					gchar** _tmp18_;
					gint _tmp18__length1;
					gchar** _tmp19_;
					gint _tmp19__length1;
					gchar** _tmp20_;
					gint _tmp20__length1;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					if (!_tmp15_) {
						gint _tmp16_;
						_tmp16_ = i;
						i = _tmp16_ + 1;
					}
					_tmp15_ = FALSE;
					_tmp17_ = ascii_tokens;
					_tmp17__length1 = ascii_tokens_length1;
					if (!(i < _tmp17__length1)) {
						break;
					}
					_tmp18_ = ascii_tokens;
					_tmp18__length1 = ascii_tokens_length1;
					_tmp19_ = unicode_tokens;
					_tmp19__length1 = unicode_tokens_length1;
					_tmp20_ = ascii_tokens;
					_tmp20__length1 = ascii_tokens_length1;
					_tmp21_ = _tmp20_[i];
					_tmp22_ = g_strdup (_tmp21_);
					_g_free0 (_tmp18_[_tmp19__length1 + i]);
					_tmp18_[_tmp19__length1 + i] = _tmp22_;
				}
			}
		}
		_tmp23_ = all_tokens;
		_tmp23__length1 = all_tokens_length1;
		_tmp24_ = (_tmp23_ != NULL) ? _vala_array_dup3 (_tmp23_, _tmp23__length1) : ((gpointer) _tmp23_);
		_tmp24__length1 = _tmp23__length1;
		child->search_tokens = (_vala_array_free (child->search_tokens, child->search_tokens_length1, (GDestroyNotify) g_free), NULL);
		child->search_tokens = _tmp24_;
		child->search_tokens_length1 = _tmp24__length1;
		child->_search_tokens_size_ = child->search_tokens_length1;
		all_tokens = (_vala_array_free (all_tokens, all_tokens_length1, (GDestroyNotify) g_free), NULL);
		ascii_tokens = (_vala_array_free (ascii_tokens, ascii_tokens_length1, (GDestroyNotify) g_free), NULL);
		unicode_tokens = (_vala_array_free (unicode_tokens, unicode_tokens_length1, (GDestroyNotify) g_free), NULL);
	}
	all_matched = TRUE;
	{
		gchar** needle_collection = NULL;
		gint needle_collection_length1 = 0;
		gint _needle_collection_size_ = 0;
		gint needle_it = 0;
		needle_collection = _data8_->needle_tokens;
		needle_collection_length1 = _data8_->needle_tokens_length1;
		for (needle_it = 0; needle_it < needle_collection_length1; needle_it = needle_it + 1) {
			gchar* _tmp25_;
			gchar* needle = NULL;
			_tmp25_ = g_strdup (needle_collection[needle_it]);
			needle = _tmp25_;
			{
				gboolean needle_matched = FALSE;
				gchar** _tmp26_;
				gint _tmp26__length1;
				needle_matched = FALSE;
				_tmp26_ = child->search_tokens;
				_tmp26__length1 = child->search_tokens_length1;
				{
					gchar** token_collection = NULL;
					gint token_collection_length1 = 0;
					gint _token_collection_size_ = 0;
					gint token_it = 0;
					token_collection = _tmp26_;
					token_collection_length1 = _tmp26__length1;
					for (token_it = 0; token_it < token_collection_length1; token_it = token_it + 1) {
						gchar* _tmp27_;
						gchar* token = NULL;
						_tmp27_ = g_strdup (token_collection[token_it]);
						token = _tmp27_;
						{
							const gchar* _tmp28_;
							const gchar* _tmp29_;
							_tmp28_ = token;
							_tmp29_ = needle;
							if (string_contains (_tmp28_, _tmp29_)) {
								needle_matched = TRUE;
								_g_free0 (token);
								break;
							}
							_g_free0 (token);
						}
					}
				}
				if (!needle_matched) {
					all_matched = FALSE;
					_g_free0 (needle);
					break;
				}
				_g_free0 (needle);
			}
		}
	}
	if (all_matched) {
		file_store_insert_file (self, child);
	}
	file_store_recursive_search (self, _data8_->needle_tokens, (gint) _data8_->needle_tokens_length1, child);
}

static void
___lambda31__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
	__lambda31_ (self, (const gchar*) key, (FileStoreFileNode*) value);
}

static void
file_store_recursive_search (FileStore* self,
                             gchar** needle_tokens,
                             gint needle_tokens_length1,
                             FileStoreFileNode* node)
{
	Block8Data* _data8_;
	GHashTable* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_data8_->self = g_object_ref (self);
	_data8_->needle_tokens = needle_tokens;
	_data8_->needle_tokens_length1 = needle_tokens_length1;
	_tmp0_ = node->children;
	g_hash_table_foreach (_tmp0_, ___lambda31__gh_func, _data8_);
	block8_data_unref (_data8_);
	_data8_ = NULL;
}

static void
__lambda30_ (FileStore* self,
             const gchar* name,
             FileStoreFileNode* child)
{
	g_return_if_fail (name != NULL);
	g_return_if_fail (child != NULL);
	file_store_insert_file (self, child);
}

static void
___lambda30__gh_func (gconstpointer key,
                      gconstpointer value,
                      gpointer self)
{
	__lambda30_ ((FileStore*) self, (const gchar*) key, (FileStoreFileNode*) value);
}

static void
file_store_set_current (FileStore* self,
                        FileStoreFileNode* node)
{
	FileStoreFileNode* _tmp0_;
	FileStoreFileNode* _tmp1_;
	FileStoreFileNode* _tmp2_;
	FileStoreFileNode* _tmp3_;
	GHashTable* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	gtk_list_store_clear ((GtkListStore*) self);
	_tmp0_ = _file_store_file_node_ref0 (node);
	_file_store_file_node_unref0 (self->priv->current);
	self->priv->current = _tmp0_;
	_tmp1_ = self->priv->current;
	_tmp2_ = self->priv->root;
	file_store_set_can_go_up (self, _tmp1_ != _tmp2_);
	_tmp3_ = self->priv->current;
	_tmp4_ = _tmp3_->children;
	g_hash_table_foreach (_tmp4_, ___lambda30__gh_func, self);
}

static gchar*
file_store_collate_key (FileStore* self,
                        FileStoreFileNode* node)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* prefix = NULL;
	gchar* _tmp2_;
	gchar* key = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (node != NULL, NULL);
	_tmp1_ = node->type;
	if (g_strcmp0 (_tmp1_, "dir") == 0) {
		_tmp0_ = "0:";
	} else {
		_tmp0_ = "1:";
	}
	_tmp2_ = g_strdup (_tmp0_);
	prefix = _tmp2_;
	_tmp3_ = node->filename;
	_tmp4_ = g_utf8_collate_key_for_filename (_tmp3_, (gssize) -1);
	key = _tmp4_;
	_tmp5_ = g_strconcat (prefix, key, NULL);
	result = _tmp5_;
	_g_free0 (key);
	_g_free0 (prefix);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
file_store_insert_file (FileStore* self,
                        FileStoreFileNode* node)
{
	GtkIconTheme* theme = NULL;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* content_type = NULL;
	gchar* _tmp7_;
	GIcon* gicon = NULL;
	const gchar* _tmp8_;
	GIcon* _tmp9_;
	GtkIconInfo* info = NULL;
	GtkIconTheme* _tmp10_;
	GIcon* _tmp11_;
	GtkIconInfo* _tmp12_;
	GdkPixbuf* icon = NULL;
	FileStoreFileNode* iter = NULL;
	FileStoreFileNode* _tmp18_;
	gchar* path = NULL;
	const gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	GdkPixbuf* _tmp38_;
	GIcon* _tmp39_;
	GDateTime* _tmp40_;
	const gchar* _tmp41_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	_tmp0_ = gtk_icon_theme_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	theme = _tmp1_;
	_tmp3_ = node->type;
	if (g_strcmp0 (_tmp3_, "dir") == 0) {
		gchar* _tmp4_;
		_tmp4_ = g_content_type_from_mime_type ("inode/directory");
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp4_;
	} else {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = node->filename;
		_tmp6_ = g_content_type_guess (_tmp5_, NULL, (gsize) 0, NULL);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp6_;
	}
	_tmp7_ = g_strdup (_tmp2_);
	content_type = _tmp7_;
	_tmp8_ = content_type;
	_tmp9_ = g_content_type_get_icon (_tmp8_);
	gicon = _tmp9_;
	_tmp10_ = theme;
	_tmp11_ = gicon;
	_tmp12_ = gtk_icon_theme_lookup_by_gicon (_tmp10_, _tmp11_, 64, GTK_ICON_LOOKUP_FORCE_SIZE);
	info = _tmp12_;
	icon = NULL;
	{
		GtkIconInfo* _tmp13_;
		_tmp13_ = info;
		if (_tmp13_ != NULL) {
			GdkPixbuf* _tmp14_ = NULL;
			GtkIconInfo* _tmp15_;
			GdkPixbuf* _tmp16_;
			GdkPixbuf* _tmp17_;
			_tmp15_ = info;
			_tmp16_ = gtk_icon_info_load_icon (_tmp15_, &_inner_error0_);
			_tmp14_ = _tmp16_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp17_ = _tmp14_;
			_tmp14_ = NULL;
			_g_object_unref0 (icon);
			icon = _tmp17_;
			_g_object_unref0 (_tmp14_);
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (icon);
		_g_object_unref0 (info);
		_g_object_unref0 (gicon);
		_g_free0 (content_type);
		_g_free0 (_tmp2_);
		_g_object_unref0 (theme);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp18_ = _file_store_file_node_ref0 (node);
	iter = _tmp18_;
	path = NULL;
	while (TRUE) {
		FileStoreFileNode* _tmp19_;
		FileStoreFileNode* _tmp20_;
		FileStoreFileNode* _tmp21_;
		const gchar* _tmp22_;
		FileStoreFileNode* _tmp32_;
		FileStoreFileNode* _tmp33_;
		FileStoreFileNode* _tmp34_;
		_tmp19_ = iter;
		_tmp20_ = _tmp19_->parent;
		_tmp21_ = self->priv->current;
		if (!(_tmp20_ != _tmp21_)) {
			break;
		}
		_tmp22_ = path;
		if (_tmp22_ == NULL) {
			FileStoreFileNode* _tmp23_;
			FileStoreFileNode* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			_tmp23_ = iter;
			_tmp24_ = _tmp23_->parent;
			_tmp25_ = _tmp24_->filename;
			_tmp26_ = g_strdup (_tmp25_);
			_g_free0 (path);
			path = _tmp26_;
		} else {
			FileStoreFileNode* _tmp27_;
			FileStoreFileNode* _tmp28_;
			const gchar* _tmp29_;
			const gchar* _tmp30_;
			gchar* _tmp31_;
			_tmp27_ = iter;
			_tmp28_ = _tmp27_->parent;
			_tmp29_ = _tmp28_->filename;
			_tmp30_ = path;
			_tmp31_ = g_strdup_printf ("%s/%s", _tmp29_, _tmp30_);
			_g_free0 (path);
			path = _tmp31_;
		}
		_tmp32_ = iter;
		_tmp33_ = _tmp32_->parent;
		_tmp34_ = _file_store_file_node_ref0 (_tmp33_);
		_file_store_file_node_unref0 (iter);
		iter = _tmp34_;
	}
	_tmp35_ = node->filename;
	_tmp36_ = file_store_collate_key (self, node);
	_tmp37_ = _tmp36_;
	_tmp38_ = icon;
	_tmp39_ = gicon;
	_tmp40_ = node->modified;
	_tmp41_ = path;
	gtk_list_store_insert_with_values ((GtkListStore*) self, NULL, -1, FILE_STORE_COLUMN_FILENAME, _tmp35_, FILE_STORE_COLUMN_SORT_KEY, _tmp37_, FILE_STORE_COLUMN_ICON, _tmp38_, FILE_STORE_COLUMN_GICON, _tmp39_, FILE_STORE_COLUMN_MODIFIED, _tmp40_, FILE_STORE_COLUMN_PATH, _tmp41_, -1);
	_g_free0 (_tmp37_);
	_g_free0 (path);
	_file_store_file_node_unref0 (iter);
	_g_object_unref0 (icon);
	_g_object_unref0 (info);
	_g_object_unref0 (gicon);
	_g_free0 (content_type);
	_g_free0 (_tmp2_);
	_g_object_unref0 (theme);
}

static void
file_store_handle_listed_files (FileStore* self,
                                DejaDupOperationFiles* op,
                                const gchar* date,
                                const gchar* file,
                                const gchar* type)
{
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	FileStoreFileNode* iter = NULL;
	FileStoreFileNode* _tmp2_;
	FileStoreFileNode* _tmp3_;
	FileStoreFileNode* parent = NULL;
	FileStoreFileNode* _tmp4_;
	FileStoreFileNode* _tmp5_;
	GDateTime* datetime = NULL;
	GTimeZone* _tmp6_;
	GTimeZone* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	g_return_if_fail (date != NULL);
	g_return_if_fail (file != NULL);
	g_return_if_fail (type != NULL);
	_tmp1_ = _tmp0_ = g_strsplit (file, "/", 0);
	parts = _tmp1_;
	parts_length1 = _vala_array_length (_tmp0_);
	_parts_size_ = parts_length1;
	_tmp2_ = self->priv->root;
	_tmp3_ = _file_store_file_node_ref0 (_tmp2_);
	iter = _tmp3_;
	_tmp4_ = iter;
	_tmp5_ = _file_store_file_node_ref0 (_tmp4_);
	parent = _tmp5_;
	_tmp6_ = g_time_zone_new_utc ();
	_tmp7_ = _tmp6_;
	_tmp8_ = g_date_time_new_from_iso8601 (date, _tmp7_);
	_tmp9_ = _tmp8_;
	_g_time_zone_unref0 (_tmp7_);
	datetime = _tmp9_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp10_ = FALSE;
			_tmp10_ = TRUE;
			while (TRUE) {
				gchar** _tmp12_;
				gint _tmp12__length1;
				FileStoreFileNode* _tmp13_;
				FileStoreFileNode* _tmp14_;
				FileStoreFileNode* _tmp15_;
				GHashTable* _tmp16_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				const gchar* _tmp18_;
				gconstpointer _tmp19_;
				FileStoreFileNode* _tmp20_;
				FileStoreFileNode* _tmp21_;
				if (!_tmp10_) {
					gint _tmp11_;
					_tmp11_ = i;
					i = _tmp11_ + 1;
				}
				_tmp10_ = FALSE;
				_tmp12_ = parts;
				_tmp12__length1 = parts_length1;
				if (!(i < _tmp12__length1)) {
					break;
				}
				_tmp13_ = iter;
				_tmp14_ = _file_store_file_node_ref0 (_tmp13_);
				_file_store_file_node_unref0 (parent);
				parent = _tmp14_;
				_tmp15_ = parent;
				_tmp16_ = _tmp15_->children;
				_tmp17_ = parts;
				_tmp17__length1 = parts_length1;
				_tmp18_ = _tmp17_[i];
				_tmp19_ = g_hash_table_lookup (_tmp16_, _tmp18_);
				_tmp20_ = _file_store_file_node_ref0 ((FileStoreFileNode*) _tmp19_);
				_file_store_file_node_unref0 (iter);
				iter = _tmp20_;
				_tmp21_ = iter;
				if (_tmp21_ == NULL) {
					const gchar* _tmp22_ = NULL;
					gchar** _tmp23_;
					gint _tmp23__length1;
					gchar* part_type = NULL;
					gchar* _tmp24_;
					FileStoreFileNode* _tmp25_;
					gchar** _tmp26_;
					gint _tmp26__length1;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					GDateTime* _tmp29_;
					FileStoreFileNode* _tmp30_;
					FileStoreFileNode* _tmp31_;
					GHashTable* _tmp32_;
					gchar** _tmp33_;
					gint _tmp33__length1;
					const gchar* _tmp34_;
					gchar* _tmp35_;
					FileStoreFileNode* _tmp36_;
					FileStoreFileNode* _tmp37_;
					_tmp23_ = parts;
					_tmp23__length1 = parts_length1;
					if (i == (_tmp23__length1 - 1)) {
						_tmp22_ = type;
					} else {
						_tmp22_ = "dir";
					}
					_tmp24_ = g_strdup (_tmp22_);
					part_type = _tmp24_;
					_tmp25_ = parent;
					_tmp26_ = parts;
					_tmp26__length1 = parts_length1;
					_tmp27_ = _tmp26_[i];
					_tmp28_ = part_type;
					_tmp29_ = datetime;
					_tmp30_ = file_store_file_node_new (_tmp25_, _tmp27_, _tmp28_, _tmp29_);
					_file_store_file_node_unref0 (iter);
					iter = _tmp30_;
					_tmp31_ = parent;
					_tmp32_ = _tmp31_->children;
					_tmp33_ = parts;
					_tmp33__length1 = parts_length1;
					_tmp34_ = _tmp33_[i];
					_tmp35_ = g_strdup (_tmp34_);
					_tmp36_ = iter;
					_tmp37_ = _file_store_file_node_ref0 (_tmp36_);
					g_hash_table_insert (_tmp32_, _tmp35_, _tmp37_);
					_g_free0 (part_type);
				}
			}
		}
	}
	_g_date_time_unref0 (datetime);
	_file_store_file_node_unref0 (parent);
	_file_store_file_node_unref0 (iter);
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
}

static void
file_store_clear_metadir (FileStore* self)
{
	GFile* part_iter = NULL;
	GFile* _tmp0_;
	GList* parts = NULL;
	FileStoreFileNode* metadir_node = NULL;
	FileStoreFileNode* _tmp6_;
	FileStoreFileNode* _tmp7_;
	GList* _tmp8_;
	FileStoreFileNode* node_iter = NULL;
	FileStoreFileNode* _tmp16_;
	FileStoreFileNode* _tmp17_;
	g_return_if_fail (self != NULL);
	_tmp0_ = deja_dup_get_metadir ();
	part_iter = _tmp0_;
	parts = NULL;
	while (TRUE) {
		GFile* _tmp1_;
		GFile* _tmp2_;
		gchar* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		_tmp1_ = part_iter;
		if (!g_file_has_parent (_tmp1_, NULL)) {
			break;
		}
		_tmp2_ = part_iter;
		_tmp3_ = g_file_get_basename (_tmp2_);
		parts = g_list_prepend (parts, _tmp3_);
		_tmp4_ = part_iter;
		_tmp5_ = g_file_get_parent (_tmp4_);
		_g_object_unref0 (part_iter);
		part_iter = _tmp5_;
	}
	_tmp6_ = self->priv->root;
	_tmp7_ = _file_store_file_node_ref0 (_tmp6_);
	metadir_node = _tmp7_;
	_tmp8_ = parts;
	{
		GList* part_collection = NULL;
		GList* part_it = NULL;
		part_collection = _tmp8_;
		for (part_it = part_collection; part_it != NULL; part_it = part_it->next) {
			gchar* _tmp9_;
			gchar* part = NULL;
			_tmp9_ = g_strdup ((const gchar*) part_it->data);
			part = _tmp9_;
			{
				FileStoreFileNode* _tmp10_;
				GHashTable* _tmp11_;
				const gchar* _tmp12_;
				gconstpointer _tmp13_;
				FileStoreFileNode* _tmp14_;
				FileStoreFileNode* _tmp15_;
				_tmp10_ = metadir_node;
				_tmp11_ = _tmp10_->children;
				_tmp12_ = part;
				_tmp13_ = g_hash_table_lookup (_tmp11_, _tmp12_);
				_tmp14_ = _file_store_file_node_ref0 ((FileStoreFileNode*) _tmp13_);
				_file_store_file_node_unref0 (metadir_node);
				metadir_node = _tmp14_;
				_tmp15_ = metadir_node;
				if (_tmp15_ == NULL) {
					_g_free0 (part);
					_file_store_file_node_unref0 (metadir_node);
					(parts == NULL) ? NULL : (parts = (_g_list_free__g_free0_ (parts), NULL));
					_g_object_unref0 (part_iter);
					return;
				}
				_g_free0 (part);
			}
		}
	}
	_tmp16_ = metadir_node;
	_tmp17_ = _file_store_file_node_ref0 (_tmp16_);
	node_iter = _tmp17_;
	while (TRUE) {
		FileStoreFileNode* _tmp18_;
		FileStoreFileNode* _tmp19_;
		FileStoreFileNode* parent = NULL;
		FileStoreFileNode* _tmp20_;
		FileStoreFileNode* _tmp21_;
		FileStoreFileNode* _tmp22_;
		FileStoreFileNode* _tmp23_;
		GHashTable* _tmp24_;
		FileStoreFileNode* _tmp25_;
		const gchar* _tmp26_;
		FileStoreFileNode* _tmp27_;
		GHashTable* _tmp28_;
		guint _tmp29_;
		guint _tmp30_;
		FileStoreFileNode* _tmp31_;
		FileStoreFileNode* _tmp32_;
		_tmp18_ = node_iter;
		_tmp19_ = _tmp18_->parent;
		if (!(_tmp19_ != NULL)) {
			break;
		}
		_tmp20_ = node_iter;
		_tmp21_ = _tmp20_->parent;
		_tmp22_ = _file_store_file_node_ref0 (_tmp21_);
		parent = _tmp22_;
		_tmp23_ = parent;
		_tmp24_ = _tmp23_->children;
		_tmp25_ = node_iter;
		_tmp26_ = _tmp25_->filename;
		g_hash_table_remove (_tmp24_, _tmp26_);
		_tmp27_ = parent;
		_tmp28_ = _tmp27_->children;
		_tmp29_ = g_hash_table_size (_tmp28_);
		_tmp30_ = _tmp29_;
		if (_tmp30_ > ((guint) 0)) {
			_file_store_file_node_unref0 (parent);
			break;
		}
		_tmp31_ = parent;
		_tmp32_ = _file_store_file_node_ref0 (_tmp31_);
		_file_store_file_node_unref0 (node_iter);
		node_iter = _tmp32_;
		_file_store_file_node_unref0 (parent);
	}
	_file_store_file_node_unref0 (node_iter);
	_file_store_file_node_unref0 (metadir_node);
	(parts == NULL) ? NULL : (parts = (_g_list_free__g_free0_ (parts), NULL));
	_g_object_unref0 (part_iter);
}

static void
file_store_handle_done (FileStore* self,
                        DejaDupOperation* op,
                        gboolean success,
                        gboolean cancelled,
                        const gchar* detail)
{
	gboolean _tmp0_ = FALSE;
	FileStoreFileNode* _tmp16_;
	FileStoreFileNode* _tmp17_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (op != NULL);
	if (!success) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = cancelled;
	}
	if (_tmp0_) {
		return;
	}
	file_store_clear_metadir (self);
	while (TRUE) {
		FileStoreFileNode* _tmp1_;
		GHashTable* _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
		FileStoreFileNode* child = NULL;
		FileStoreFileNode* _tmp5_;
		GHashTable* _tmp6_;
		GList* _tmp7_;
		GList* _tmp8_;
		gconstpointer _tmp9_;
		FileStoreFileNode* _tmp10_;
		FileStoreFileNode* _tmp11_;
		FileStoreFileNode* _tmp12_;
		const gchar* _tmp13_;
		FileStoreFileNode* _tmp14_;
		FileStoreFileNode* _tmp15_;
		_tmp1_ = self->priv->root;
		_tmp2_ = _tmp1_->children;
		_tmp3_ = g_hash_table_size (_tmp2_);
		_tmp4_ = _tmp3_;
		if (!(_tmp4_ == ((guint) 1))) {
			break;
		}
		_tmp5_ = self->priv->root;
		_tmp6_ = _tmp5_->children;
		_tmp7_ = g_hash_table_get_values (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = _tmp8_->data;
		_tmp10_ = _file_store_file_node_ref0 ((FileStoreFileNode*) _tmp9_);
		_tmp11_ = _tmp10_;
		(_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_list_free (_tmp8_), NULL));
		child = _tmp11_;
		_tmp12_ = child;
		_tmp13_ = _tmp12_->type;
		if (g_strcmp0 (_tmp13_, "dir") != 0) {
			_file_store_file_node_unref0 (child);
			break;
		}
		_tmp14_ = child;
		_tmp15_ = _file_store_file_node_ref0 (_tmp14_);
		_file_store_file_node_unref0 (self->priv->root);
		self->priv->root = _tmp15_;
		_file_store_file_node_unref0 (child);
	}
	_tmp16_ = self->priv->root;
	_tmp16_->parent = NULL;
	_tmp17_ = self->priv->root;
	file_store_set_current (self, _tmp17_);
}

FileStore*
file_store_construct (GType object_type)
{
	FileStore * self = NULL;
	self = (FileStore*) g_object_new (object_type, NULL);
	return self;
}

FileStore*
file_store_new (void)
{
	return file_store_construct (TYPE_FILE_STORE);
}

gboolean
file_store_get_can_go_up (FileStore* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_can_go_up;
	return result;
}

static void
file_store_set_can_go_up (FileStore* self,
                          gboolean value)
{
	g_return_if_fail (self != NULL);
	if (file_store_get_can_go_up (self) != value) {
		self->priv->_can_go_up = value;
		g_object_notify_by_pspec ((GObject *) self, file_store_properties[FILE_STORE_CAN_GO_UP_PROPERTY]);
	}
}

const gchar*
file_store_get_search_filter (FileStore* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_search_filter;
	result = _tmp0_;
	return result;
}

void
file_store_set_search_filter (FileStore* self,
                              const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, file_store_get_search_filter (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_search_filter);
		self->priv->_search_filter = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, file_store_properties[FILE_STORE_SEARCH_FILTER_PROPERTY]);
	}
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

static void
_file_store_file_node_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (file_store_file_node_unref (var), NULL));
}

static FileStoreFileNode*
file_store_file_node_construct (GType object_type,
                                FileStoreFileNode* parent_in,
                                const gchar* filename_in,
                                const gchar* type_in,
                                GDateTime* modified_in)
{
	FileStoreFileNode* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GDateTime* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	g_return_val_if_fail (filename_in != NULL, NULL);
	g_return_val_if_fail (type_in != NULL, NULL);
	self = (FileStoreFileNode*) g_type_create_instance (object_type);
	_tmp0_ = g_strdup (filename_in);
	_g_free0 (self->filename);
	self->filename = _tmp0_;
	self->parent = parent_in;
	_tmp1_ = g_strdup (type_in);
	_g_free0 (self->type);
	self->type = _tmp1_;
	_tmp2_ = _g_date_time_ref0 (modified_in);
	_g_date_time_unref0 (self->modified);
	self->modified = _tmp2_;
	_tmp3_ = g_str_hash;
	_tmp4_ = g_str_equal;
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _file_store_file_node_unref0_);
	_g_hash_table_unref0 (self->children);
	self->children = _tmp5_;
	return self;
}

static FileStoreFileNode*
file_store_file_node_new (FileStoreFileNode* parent_in,
                          const gchar* filename_in,
                          const gchar* type_in,
                          GDateTime* modified_in)
{
	return file_store_file_node_construct (FILE_STORE_TYPE_FILE_NODE, parent_in, filename_in, type_in, modified_in);
}

static void
file_store_value_file_node_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
file_store_value_file_node_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		file_store_file_node_unref (value->data[0].v_pointer);
	}
}

static void
file_store_value_file_node_copy_value (const GValue* src_value,
                                       GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = file_store_file_node_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
file_store_value_file_node_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
file_store_value_file_node_collect_value (GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		FileStoreFileNode * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = file_store_file_node_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
file_store_value_file_node_lcopy_value (const GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	FileStoreFileNode ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = file_store_file_node_ref (value->data[0].v_pointer);
	}
	return NULL;
}

static GParamSpec*
file_store_param_spec_file_node (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags)
{
	FileStoreParamSpecFileNode* spec;
	g_return_val_if_fail (g_type_is_a (object_type, FILE_STORE_TYPE_FILE_NODE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

static gpointer
file_store_value_get_file_node (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, FILE_STORE_TYPE_FILE_NODE), NULL);
	return value->data[0].v_pointer;
}

static void
file_store_value_set_file_node (GValue* value,
                                gpointer v_object)
{
	FileStoreFileNode * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, FILE_STORE_TYPE_FILE_NODE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, FILE_STORE_TYPE_FILE_NODE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		file_store_file_node_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		file_store_file_node_unref (old);
	}
}

static void
file_store_value_take_file_node (GValue* value,
                                 gpointer v_object)
{
	FileStoreFileNode * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, FILE_STORE_TYPE_FILE_NODE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, FILE_STORE_TYPE_FILE_NODE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		file_store_file_node_unref (old);
	}
}

static void
file_store_file_node_class_init (FileStoreFileNodeClass * klass,
                                 gpointer klass_data)
{
	file_store_file_node_parent_class = g_type_class_peek_parent (klass);
	((FileStoreFileNodeClass *) klass)->finalize = file_store_file_node_finalize;
}

static void
file_store_file_node_instance_init (FileStoreFileNode * self,
                                    gpointer klass)
{
	self->ref_count = 1;
}

static void
file_store_file_node_finalize (FileStoreFileNode * obj)
{
	FileStoreFileNode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILE_STORE_TYPE_FILE_NODE, FileStoreFileNode);
	g_signal_handlers_destroy (self);
	_g_free0 (self->filename);
	_g_free0 (self->type);
	_g_date_time_unref0 (self->modified);
	_g_hash_table_unref0 (self->children);
	self->search_tokens = (_vala_array_free (self->search_tokens, self->search_tokens_length1, (GDestroyNotify) g_free), NULL);
}

G_GNUC_NO_INLINE static GType
file_store_file_node_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { file_store_value_file_node_init, file_store_value_file_node_free_value, file_store_value_file_node_copy_value, file_store_value_file_node_peek_pointer, "p", file_store_value_file_node_collect_value, "p", file_store_value_file_node_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (FileStoreFileNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_store_file_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileStoreFileNode), 0, (GInstanceInitFunc) file_store_file_node_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType file_store_file_node_type_id;
	file_store_file_node_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FileStoreFileNode", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return file_store_file_node_type_id;
}

static GType
file_store_file_node_get_type (void)
{
	static volatile gsize file_store_file_node_type_id__volatile = 0;
	if (g_once_init_enter (&file_store_file_node_type_id__volatile)) {
		GType file_store_file_node_type_id;
		file_store_file_node_type_id = file_store_file_node_get_type_once ();
		g_once_init_leave (&file_store_file_node_type_id__volatile, file_store_file_node_type_id);
	}
	return file_store_file_node_type_id__volatile;
}

static gpointer
file_store_file_node_ref (gpointer instance)
{
	FileStoreFileNode * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

static void
file_store_file_node_unref (gpointer instance)
{
	FileStoreFileNode * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		FILE_STORE_FILE_NODE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static gint
_file_store___lambda32_ (FileStore* self,
                         GtkTreeModel* m,
                         GtkTreeIter* a,
                         GtkTreeIter* b)
{
	gchar* akey = NULL;
	gchar* bkey = NULL;
	GtkTreeIter _tmp0_;
	gchar* _tmp1_ = NULL;
	GtkTreeIter _tmp2_;
	gchar* _tmp3_ = NULL;
	GCompareFunc _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gint result = 0;
	g_return_val_if_fail (m != NULL, 0);
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = *a;
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp0_, FILE_STORE_COLUMN_SORT_KEY, &_tmp1_, -1);
	_g_free0 (akey);
	akey = _tmp1_;
	_tmp2_ = *b;
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp2_, FILE_STORE_COLUMN_SORT_KEY, &_tmp3_, -1);
	_g_free0 (bkey);
	bkey = _tmp3_;
	_tmp4_ = ((GCompareFunc) g_strcmp0);
	_tmp5_ = akey;
	_tmp6_ = bkey;
	result = _tmp4_ (_tmp5_, _tmp6_);
	_g_free0 (bkey);
	_g_free0 (akey);
	return result;
}

static gint
__file_store___lambda32__gtk_tree_iter_compare_func (GtkTreeModel* model,
                                                     GtkTreeIter* a,
                                                     GtkTreeIter* b,
                                                     gpointer self)
{
	gint result;
	result = _file_store___lambda32_ ((FileStore*) self, model, a, b);
	return result;
}

static void
_file_store_update_search_g_object_notify (GObject* _sender,
                                           GParamSpec* pspec,
                                           gpointer self)
{
	file_store_update_search ((FileStore*) self);
}

static GObject *
file_store_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FileStore * self;
	GType* _tmp0_;
	GType* _tmp1_;
	gint _tmp1__length1;
	parent_class = G_OBJECT_CLASS (file_store_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_STORE, FileStore);
	_tmp0_ = g_new0 (GType, 6);
	_tmp0_[0] = G_TYPE_STRING;
	_tmp0_[1] = G_TYPE_STRING;
	_tmp0_[2] = gdk_pixbuf_get_type ();
	_tmp0_[3] = g_icon_get_type ();
	_tmp0_[4] = G_TYPE_DATE_TIME;
	_tmp0_[5] = G_TYPE_STRING;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = 6;
	gtk_list_store_set_column_types ((GtkListStore*) self, (gint) 6, _tmp1_);
	_tmp1_ = (g_free (_tmp1_), NULL);
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, (gint) FILE_STORE_COLUMN_FILENAME, GTK_SORT_ASCENDING);
	gtk_tree_sortable_set_sort_func ((GtkTreeSortable*) self, (gint) FILE_STORE_COLUMN_FILENAME, __file_store___lambda32__gtk_tree_iter_compare_func, g_object_ref (self), g_object_unref);
	g_signal_connect_object ((GObject*) self, "notify::search-filter", (GCallback) _file_store_update_search_g_object_notify, self, 0);
	return obj;
}

static void
file_store_class_init (FileStoreClass * klass,
                       gpointer klass_data)
{
	file_store_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FileStore_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_file_store_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_file_store_set_property;
	G_OBJECT_CLASS (klass)->constructor = file_store_constructor;
	G_OBJECT_CLASS (klass)->finalize = file_store_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_CAN_GO_UP_PROPERTY, file_store_properties[FILE_STORE_CAN_GO_UP_PROPERTY] = g_param_spec_boolean ("can-go-up", "can-go-up", "can-go-up", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_STORE_SEARCH_FILTER_PROPERTY, file_store_properties[FILE_STORE_SEARCH_FILTER_PROPERTY] = g_param_spec_string ("search-filter", "search-filter", "search-filter", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
file_store_instance_init (FileStore * self,
                          gpointer klass)
{
	self->priv = file_store_get_instance_private (self);
	self->priv->_can_go_up = FALSE;
	self->priv->_search_filter = NULL;
}

static void
file_store_finalize (GObject * obj)
{
	FileStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_STORE, FileStore);
	_g_free0 (self->priv->_search_filter);
	_file_store_file_node_unref0 (self->priv->root);
	_file_store_file_node_unref0 (self->priv->current);
	G_OBJECT_CLASS (file_store_parent_class)->finalize (obj);
}

G_GNUC_NO_INLINE static GType
file_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FileStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileStore), 0, (GInstanceInitFunc) file_store_instance_init, NULL };
	GType file_store_type_id;
	file_store_type_id = g_type_register_static (gtk_list_store_get_type (), "FileStore", &g_define_type_info, 0);
	FileStore_private_offset = g_type_add_instance_private (file_store_type_id, sizeof (FileStorePrivate));
	return file_store_type_id;
}

GType
file_store_get_type (void)
{
	static volatile gsize file_store_type_id__volatile = 0;
	if (g_once_init_enter (&file_store_type_id__volatile)) {
		GType file_store_type_id;
		file_store_type_id = file_store_get_type_once ();
		g_once_init_leave (&file_store_type_id__volatile, file_store_type_id);
	}
	return file_store_type_id__volatile;
}

static void
_vala_file_store_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	FileStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_STORE, FileStore);
	switch (property_id) {
		case FILE_STORE_CAN_GO_UP_PROPERTY:
		g_value_set_boolean (value, file_store_get_can_go_up (self));
		break;
		case FILE_STORE_SEARCH_FILTER_PROPERTY:
		g_value_set_string (value, file_store_get_search_filter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_file_store_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	FileStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_STORE, FileStore);
	switch (property_id) {
		case FILE_STORE_CAN_GO_UP_PROPERTY:
		file_store_set_can_go_up (self, g_value_get_boolean (value));
		break;
		case FILE_STORE_SEARCH_FILTER_PROPERTY:
		file_store_set_search_filter (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

